#!/bin/sh

MAKDO=.source/makdo_editor.py
test -f "$MAKDO" || exit 1

test -e ../makdo_lin && rm ../makdo_lin
mkdir .tmpdir
mkdir .tmpdir/makdo
cd .tmpdir

cp -p ../.source/makdo_editor.py .
mv makdo_editor.py makdo_lin.py
cp -p ../.source/makdo_md2docx.py makdo/makdo_md2docx.py
cp -p ../.source/makdo_docx2md.py makdo/makdo_docx2md.py
cp -p ../.source/makdo_mddiff.py makdo/makdo_mddiff.py
# cp -p ../.source/eblook.py makdo/eblook.py

python3 -m venv venv
. ./venv/bin/activate
python3 -m pip install --upgrade pip

python3 -m pip install Pyinstaller

# python3 -m pip install pywin32
python3 -m pip install python-docx
python3 -m pip install chardet
python3 -m pip install tkinterdnd2
python3 -m pip install openpyxl
python3 -m pip install Levenshtein
# python3 -m pip install openai
# python3 -m pip install llama_cpp_python

cp -rp venv/lib/python*/site-packages/tkinterdnd2 .

python3 -m PyInstaller --onefile --noconsole \
	--collect-data tkinterdnd2 \
	--add-data="tkinterdnd2/tkdnd/linux-x64:." \
	--add-data="makdo/makdo_md2docx.py:." \
	--add-data="makdo/makdo_docx2md.py:." \
	--add-data="makdo/makdo_mddiff.py:." \
	--exclude-module numpy \
	--exclude-module pandas \
	--splash=../.image/makdo_splash.png \
	--icon=../.image/makdo_win.ico \
	makdo_lin.py
#	--add-data="makdo/eblook.py:." \

deactivate

cp -p dist/makdo_lin ../../

cd ..
rm -rf .tmpdir

cd ../
ls -s makdo_lin

echo '終了します'
read -p '"Enter"を押してください' i
