#!/bin/sh

test -f .source/makdo_editor.py || exit 1

if ( ! diff ../README.md ../README.txt ); then
    echo 'error: "README.md" and "README.txt" are different' 1>&2
    exit 1
fi

rm -rf .tmpflr
rm -rf .tmpdir
rm -rf .source/__pycache__

cd ../..
test -e "makdo_lin.zip" && exit 1
test -e "makdo" || exit 1

/bin/echo -n 'version(vXX.XX)> '
read ver
date=`date +%Y-%m-%d`
echo "makdo $ver ($date)" > makdo/version
echo "Version:  makdo $ver ($date)" | zip -zr9 "makdo_lin.zip" \
    makdo/version \
    makdo/makdo_lin \
    makdo/README.md \
    makdo/README.txt \
    makdo/LICENSES.md \
    makdo/manual/manual.md \
    makdo/manual/manual.pdf \
    makdo/test_data/test_md2docx.md \
    makdo/test_data/test_docx2md.docx \
    makdo/.system/.make_pyinstaller_lin.sh \
    makdo/.system/.make_zip.sh \
    makdo/.system/.source/makdo_editor.py \
    makdo/.system/.source/makdo_md2docx.py \
    makdo/.system/.source/makdo_docx2md.py \
    makdo/.system/.source/makdo_mddiff.py \
    makdo/.system/.image/.makdo.mp \
    makdo/.system/.image/.make_images.sh \
    makdo/.system/.image/makdo_win.ico \
    makdo/.system/.image/makdo_splash.png \
    \

rm makdo/version
